<?php

define('WHAMI_SOURCE_ADAPTER_FACEBOOK_CONTENT_TYPE', 'whami_source_adapter_facebook_content_type');
define('WHAMI_SOURCE_ADAPTER_FACEBOOK_FIELD_GEO', 'whami_source_adapter_facebook_field_geo');
define('WHAMI_SOURCE_ADAPTER_FACEBOOK_SEARCH_RADIUS', 'whami_source_adapter_facebook_search_radius');
define('WHAMI_SOURCE_ADAPTER_FACEBOOK_SEARCH_LIMIT', 'whami_source_adapter_facebook_search_limit');
define('WHAMI_SOURCE_ADAPTER_FACEBOOK_DEBUG', 'whami_source_adapter_facebook_debug');
define('WHAMI_SOURCE_ADAPTER_FACEBOOK_TMP_TOKEN', 'whami_source_adapter_facebook_tmp_token');

function _whami_source_adapter_facebook_admin() {

  $form = array();

  $form[WHAMI_SOURCE_ADAPTER_FACEBOOK_DEBUG] = array(
      '#type' => 'checkbox',
      '#title' => t('Enable debug mode'),
      '#default_value' => _whami_source_adapter_facebook_debug(),
    );

  $form[WHAMI_SOURCE_ADAPTER_FACEBOOK_TMP_TOKEN] = array(
    '#type' => 'textfield',
    '#title' => t('Access token'),
    '#description' => t('The max. amount of places that will be requested from Facebook'),
    '#default_value' => _whami_source_adapter_facebook_tmp_token(),
    '#size' => 200,
    '#maxlength' => 200,
  );

  return system_settings_form($form);

}

function _whami_source_adapter_facebook_content_type_enabled($type) {
  return variable_get(WHAMI_SOURCE_ADAPTER_FACEBOOK_CONTENT_TYPE . '_' . $type, FALSE);
}

function _whami_source_adapter_facebook_get_field_geo() {
  return variable_get(WHAMI_SOURCE_ADAPTER_FACEBOOK_FIELD_GEO, '');
}

function _whami_source_adapter_facebook_search_radius() {
  return variable_get(WHAMI_SOURCE_ADAPTER_FACEBOOK_SEARCH_RADIUS, 1000);
}

function _whami_source_adapter_facebook_search_limit() {
  return variable_get(WHAMI_SOURCE_ADAPTER_FACEBOOK_SEARCH_LIMIT, 50);
}

function _whami_source_adapter_facebook_debug() {
  return variable_get(WHAMI_SOURCE_ADAPTER_FACEBOOK_DEBUG, FALSE);
}

function _whami_source_adapter_facebook_tmp_token() {
  return variable_get(WHAMI_SOURCE_ADAPTER_FACEBOOK_TMP_TOKEN, '');
}

function _whami_source_adapter_facebook_get_options_content_types() {

  $ret = array();

  $content_types = node_get_types();
  if (!empty($content_types)) {
    foreach($content_types as $type => $obj) {
      $ret[$type] = $obj->name;
    }
  }

  return $ret;

}

function _whami_source_adapter_facebook_get_options_fields($type) {

  $ret = array();

  if (module_exists('content') && function_exists('content_fields')) {
    $fields = content_fields();
    if (!empty($fields)) {

      foreach($fields as $field_name => $field) {
        if ( !strcmp($field['type'], $type) && $field['active'] ) {
          $ret[$field_name] = $field['widget']['label'];
        }
      }

    }
  }

  return $ret;

}